/*======================================================================
	See GNU.txt, CREDITS.txt, and COPYING.txt
	Quake owned by ID Software, Inc.
	Code based on FitzQuake (props to John Fitzgibbons)
	QuakeCPP by Brian "Feared" Wychopen II
======================================================================*/

#ifndef CONSOLE_H
#define CONSOLE_H

namespace Axiom
{
	extern int con_totallines;
	extern int con_backscroll;
	extern	bool con_forcedup;	// because no entities to refresh
	extern bool con_initialized;
	extern byte *con_chars;

	extern char con_lastcenterstring[]; //johnfitz

	void Con_DrawCharacter (int cx, int line, int num);

	void Con_CheckResize (void);
	void Con_Init (void);
	void Con_DrawConsole (int lines, bool drawinput);
	void Con_Print (char *txt);
	void Con_Printf (char *fmt, ...);
	void Con_Warning (char *fmt, ...); //johnfitz
	void Con_DPrintf (char *fmt, ...);
	void Con_DPrintf2 (char *fmt, ...); //johnfitz
	void Con_SafePrintf (char *fmt, ...);
	void Con_Clear_f (void);
	void Con_DrawNotify (void);
	void Con_ClearNotify (void);
	void Con_ToggleConsole_f (void);

	void Con_NotifyBox (char *text);	// during startup for sound / cd warnings

	extern char *Con_Quakebar(int len);
	extern void Con_LogCenterPrint(char *str);
	extern void Con_TabComplete();
}

#endif