/*======================================================================
	See GNU.txt, CREDITS.txt, and COPYING.txt
	Quake owned by ID Software, Inc.
	Code based on FitzQuake(props to John Fitzgibbons)
	QuakeCPP by Brian "Feared" Wychopen II
======================================================================*/

#ifndef NET_WIPX_H
#define NET_WIPX_H

#include "net.h"

namespace Axiom
{
	int  WIPX_Init();
	void WIPX_Shutdown();
	void WIPX_Listen(bool state);
	int  WIPX_OpenSocket(int port);
	int  WIPX_CloseSocket(int socket);
	int  WIPX_Connect(int socket, struct qsockaddr *addr);
	int  WIPX_CheckNewConnections(void);
	int  WIPX_Read(int socket, byte *buf, int len, struct qsockaddr *addr);
	int  WIPX_Write(int socket, byte *buf, int len, struct qsockaddr *addr);
	int  WIPX_Broadcast(int socket, byte *buf, int len);
	char *WIPX_AddrToString(struct qsockaddr *addr);
	int  WIPX_StringToAddr(char *string, struct qsockaddr *addr);
	int  WIPX_GetSocketAddr(int socket, struct qsockaddr *addr);
	int  WIPX_GetNameFromAddr(struct qsockaddr *addr, char *name);
	int  WIPX_GetAddrFromName(char *name, struct qsockaddr *addr);
	int  WIPX_AddrCompare(struct qsockaddr *addr1, struct qsockaddr *addr2);
	int  WIPX_GetSocketPort(struct qsockaddr *addr);
	int  WIPX_SetSocketPort(struct qsockaddr *addr, int port);
}

#endif